"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var yaml = require('js-yaml');
var path = require('path');
var parse_1 = require("../utils/parse");
var analysis_1 = require("../utils/analysis");
var common_1 = require("../utils/common");
var i18n_1 = require("../utils/i18n");
var component_1 = require("../component");
var logger = require("../utils/logger");
var TEMPLATE_FILE = 'template.yaml';
var CommandManager = /** @class */ (function () {
    function CommandManager(method, customerCommandName, templateFile, params) {
        this.method = method;
        this.customerCommandName = customerCommandName;
        this.deployParams = params;
        if (templateFile) {
            this.templateFile = templateFile;
        }
        else {
            var currentDir = process.cwd();
            var templateFile_1 = path.join(currentDir, "/" + TEMPLATE_FILE);
            this.templateFile = templateFile_1;
        }
    }
    CommandManager.prototype.assemblyProjectConfig = function (parse, projectName, parsedObj) {
        return __awaiter(this, void 0, void 0, function () {
            var realVariables, projectConfig;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, parse.getRealVariables(parsedObj)];
                    case 1:
                        realVariables = _a.sent();
                        projectConfig = realVariables[projectName];
                        projectConfig.ProjectName = projectName;
                        if (this.deployParams) {
                            projectConfig.Params = this.deployParams;
                        }
                        return [2 /*return*/, projectConfig];
                }
            });
        });
    };
    CommandManager.prototype.init = function () {
        return __awaiter(this, void 0, void 0, function () {
            var templateFile, outPutData, parse, parsedObj, projectConfig, componentExecute, tempResult, realVariables, analysis, executeOrderList, componentList, tempResult, item, outResult, e_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 9, , 10]);
                        logger.info(i18n_1.default.__('Start ......'));
                        templateFile = common_1.checkTemplateFile(this.templateFile);
                        if (!templateFile) return [3 /*break*/, 7];
                        outPutData = {};
                        parse = new parse_1.Parse(templateFile);
                        parsedObj = parse.getOriginalParsedObj();
                        if (!this.customerCommandName) return [3 /*break*/, 3];
                        return [4 /*yield*/, this.assemblyProjectConfig(parse, this.customerCommandName, parsedObj)];
                    case 1:
                        projectConfig = _a.sent();
                        componentExecute = new component_1.ComponentExeCute(projectConfig, this.method);
                        return [4 /*yield*/, componentExecute.init()];
                    case 2:
                        tempResult = _a.sent();
                        if (tempResult) {
                            outPutData[projectConfig.ProjectName] = tempResult;
                        }
                        return [3 /*break*/, 6];
                    case 3: return [4 /*yield*/, parse.getRealVariables(parsedObj)];
                    case 4:
                        realVariables = _a.sent();
                        analysis = new analysis_1.Analysis(realVariables, parse.dependenciesMap);
                        executeOrderList = analysis.getProjectOrder();
                        logger.info(i18n_1.default.__('It is detected that your project has the following project/projects < {{projects}} > to be execute', { projects: executeOrderList.join(',') }));
                        componentList = component_1.generateSynchronizeComponentExeList({ list: executeOrderList, parse: parse, parsedObj: parsedObj, method: this.method }, this.assemblyProjectConfig.bind(this));
                        return [4 /*yield*/, component_1.synchronizeExecuteComponentList(componentList)];
                    case 5:
                        tempResult = _a.sent();
                        for (item in tempResult) {
                            if (executeOrderList.includes(item) && tempResult[item]) {
                                outPutData[item] = tempResult[item];
                            }
                        }
                        _a.label = 6;
                    case 6:
                        outResult = void 0;
                        try {
                            outResult = yaml.safeDump(outPutData);
                        }
                        catch (ex) {
                            logger.error(ex);
                            logger.warning('Unable to format the output, the system will display the original output of the component:');
                            outResult = JSON.stringify(outPutData, null, '  ');
                        }
                        logger.success(Object.keys(outPutData).length === 0 ? i18n_1.default.__('End of method: {{method}}', { method: this.method }) : outResult);
                        return [3 /*break*/, 8];
                    case 7:
                        logger.error(i18n_1.default.__('Cannot find {{template}} file, please check the directory {{filepath}}', { template: TEMPLATE_FILE, filepath: this.templateFile }));
                        _a.label = 8;
                    case 8: return [3 /*break*/, 10];
                    case 9:
                        e_1 = _a.sent();
                        logger.error(e_1.message);
                        return [3 /*break*/, 10];
                    case 10: return [2 /*return*/];
                }
            });
        });
    };
    return CommandManager;
}());
exports.default = CommandManager;
//# sourceMappingURL=command-manager.js.map