"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
var program = require("commander");
var axios_1 = require("axios");
var logger_1 = require("../utils/logger");
var i18n_1 = require("../utils/i18n");
var search_error_1 = require("../error/search-error");
var static_variable_1 = require("../utils/static-variable");
var command_error_1 = require("../error/command-error");
var description = i18n_1.default.__('Search packages') + ".\n\n" + i18n_1.default.__('Example') + ":\n    $ s search keywords\n    $ s search keywords -p alibaba\n    $ s search keywords -t component\n";
program
    .name('s search')
    .option('-p, --provider [provider]', i18n_1.default.__('The cloud service provider.'))
    .helpOption('-h, --help', i18n_1.default.__('Display help for command'))
    .option('-t, --type [type]', i18n_1.default.__('The package type. [component/plugin/application]'))
    .description(description)
    .parse(process.argv);
(function () { return __awaiter(void 0, void 0, void 0, function () {
    var name, provider, type, err_1;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (program.args.length === 0) {
                    program.help();
                    return [2 /*return*/];
                }
                name = program.args[0];
                provider = program.provider;
                type = program.type || 'application';
                _a.label = 1;
            case 1:
                _a.trys.push([1, 3, , 4]);
                return [4 /*yield*/, search(name, provider, type)];
            case 2:
                _a.sent();
                return [3 /*break*/, 4];
            case 3:
                err_1 = _a.sent();
                throw new search_error_1.SearchError('Could not get packages.');
            case 4: return [2 /*return*/];
        }
    });
}); })().catch(function (err) {
    throw new command_error_1.CommandError(err.message);
});
function printn(n, str) {
    if (str === void 0) { str = ' '; }
    return __awaiter(this, void 0, void 0, function () {
        var temp_str, i;
        return __generator(this, function (_a) {
            temp_str = '';
            for (i = 0; i < n; i++) {
                temp_str = temp_str + str;
            }
            return [2 /*return*/, temp_str];
        });
    });
}
function search(name, provider, type) {
    return __awaiter(this, void 0, void 0, function () {
        var options, result, err_2, maxName, maxProviderType, _a, _b, entry, nameInfo, providerTypeInfo, tempNameLength, tempProviderTypeLength, _c, _d, _e, _f, _g, _h, entry, tempNameLength_1, tempConString, tempProviderTypeLength_1, e_1_1;
        var e_2, _j, e_1, _k;
        return __generator(this, function (_l) {
            switch (_l.label) {
                case 0:
                    options = {
                        url: static_variable_1.SERVERLESS_SEARCH_URL,
                        type: 'get',
                        timeout: 5000,
                        headers: {
                            'User-Agent': 's'
                        },
                        params: {
                            keyword: name,
                            type: type,
                            provider: provider
                        }
                    };
                    _l.label = 1;
                case 1:
                    _l.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, axios_1.default.request(options)];
                case 2:
                    result = _l.sent();
                    return [3 /*break*/, 4];
                case 3:
                    err_2 = _l.sent();
                    throw new search_error_1.SearchError('Search failed, error: {{error}}', { error: err_2.message });
                case 4:
                    if (result.status != 200) {
                        throw new search_error_1.SearchError('Search failed, status code: {{code}}', { code: result.status });
                    }
                    //console.log(result.data);
                    if (result.data.Error) {
                        throw new search_error_1.SearchError('Search failed, error code: {{code}}, message:{{msg}}', {
                            code: result.data.Error.Code,
                            msg: result.data.Error.Message
                        });
                    }
                    maxName = 0;
                    maxProviderType = 0;
                    try {
                        for (_a = __values(result.data.Response), _b = _a.next(); !_b.done; _b = _a.next()) {
                            entry = _b.value;
                            if (maxName < entry.name.length) {
                                maxName = entry.name.length;
                            }
                            if (maxProviderType < (entry.provider.length + entry.type.length)) {
                                maxProviderType = entry.provider.length + entry.type.length;
                            }
                        }
                    }
                    catch (e_2_1) { e_2 = { error: e_2_1 }; }
                    finally {
                        try {
                            if (_b && !_b.done && (_j = _a.return)) _j.call(_a);
                        }
                        finally { if (e_2) throw e_2.error; }
                    }
                    nameInfo = i18n_1.default.__('Name');
                    providerTypeInfo = i18n_1.default.__('Provider & Type');
                    if (nameInfo === 'Name') {
                        tempNameLength = maxName - nameInfo.length;
                        tempProviderTypeLength = maxProviderType - providerTypeInfo.length;
                    }
                    else {
                        tempNameLength = maxName - nameInfo.length * 2;
                        tempProviderTypeLength = maxProviderType - providerTypeInfo.length * 2 + 1;
                    }
                    _d = (_c = logger_1.default).info;
                    _e = "" + nameInfo;
                    return [4 /*yield*/, printn(tempNameLength, ' ')];
                case 5:
                    _f = _e + (_l.sent()) + "  " + providerTypeInfo;
                    return [4 /*yield*/, printn(tempProviderTypeLength, ' ')];
                case 6:
                    _d.apply(_c, [_f + (_l.sent()) + "   " + i18n_1.default.__('Description') + "\n"]);
                    _l.label = 7;
                case 7:
                    _l.trys.push([7, 13, 14, 15]);
                    _g = __values(result.data.Response), _h = _g.next();
                    _l.label = 8;
                case 8:
                    if (!!_h.done) return [3 /*break*/, 12];
                    entry = _h.value;
                    return [4 /*yield*/, printn(maxName - entry.name.length, ' ')];
                case 9:
                    tempNameLength_1 = _l.sent();
                    tempConString = entry.provider && entry.type ? '@' : '';
                    return [4 /*yield*/, printn(maxProviderType - entry.provider.length - entry.type.length + (entry.provider && entry.type ? 0 : 1), ' ')];
                case 10:
                    tempProviderTypeLength_1 = _l.sent();
                    logger_1.default.info("" + entry.name + tempNameLength_1 + "  " + entry.provider + tempConString + entry.type + tempProviderTypeLength_1 + "  " + entry.description);
                    _l.label = 11;
                case 11:
                    _h = _g.next();
                    return [3 /*break*/, 8];
                case 12: return [3 /*break*/, 15];
                case 13:
                    e_1_1 = _l.sent();
                    e_1 = { error: e_1_1 };
                    return [3 /*break*/, 15];
                case 14:
                    try {
                        if (_h && !_h.done && (_k = _g.return)) _k.call(_g);
                    }
                    finally { if (e_1) throw e_1.error; }
                    return [7 /*endfinally*/];
                case 15:
                    logger_1.default.info('');
                    return [2 /*return*/];
            }
        });
    });
}
//# sourceMappingURL=search.js.map