"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CheckVersion = void 0;
var axios_1 = require("axios");
var logger_1 = require("./logger");
var handler_set_config_1 = require("./handler-set-config");
var storage_1 = require("./storage");
var common_1 = require("./common");
var fs = require("fs-extra");
var static_variable_1 = require("./static-variable");
var get_manager_1 = require("../config/get/get-manager");
var common_2 = require("../config/common/common");
var pkg = require('../../package.json');
var CheckVersion = /** @class */ (function () {
    function CheckVersion() {
        this.hasCheckedToday = false;
    }
    CheckVersion.prototype.init = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.checkTime()];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, this.getVersion()];
                    case 2:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    CheckVersion.prototype.showMessage = function () {
        return __awaiter(this, void 0, void 0, function () {
            var isSelectVersion, _a, status, statusText, data, isNewVersion, isRequestSucc, release_version, local_version, release_version_line_length, local_version_line_length;
            return __generator(this, function (_b) {
                isSelectVersion = process.argv.includes('-v') || process.argv.includes('--version');
                _a = this.checkVersionResult, status = _a.status, statusText = _a.statusText, data = _a.data;
                isNewVersion = data.version === pkg.version;
                isRequestSucc = status === undefined || !(status === 200 && statusText === 'OK');
                if (!isSelectVersion) {
                    // 当天还没有输出过相关信息 && 如果请求成功 || 不是最新的版本
                    if (!this.hasCheckedToday && (isRequestSucc || !isNewVersion)) {
                        release_version = "Release: " + data.version;
                        local_version = "Local  : " + pkg.version;
                        release_version_line_length = 36 - release_version.length;
                        local_version_line_length = 36 - local_version.length;
                        logger_1.default.log('\n   ╭──────────────────────────────────────────╮');
                        logger_1.default.log('   │              Serverless Tool             │');
                        logger_1.default.log('   │                                          │');
                        logger_1.default.log('   │      ' + release_version + common_1.printn(release_version_line_length, ' ') + '│');
                        logger_1.default.log('   │      ' + local_version + common_1.printn(local_version_line_length, ' ') + '│');
                        logger_1.default.log('   │                                          │');
                        logger_1.default.log('   │                                          │');
                        logger_1.default.log('   │    You can upgrade through:              │');
                        logger_1.default.log('   │      npm install @serverless-devs/s -g   │');
                        logger_1.default.log('   ╰──────────────────────────────────────────╯\n');
                    }
                }
                else {
                    if (isNewVersion) {
                        logger_1.default.log("Serverless Tool Version: " + pkg.version + " ");
                        console.log('\n\n');
                    }
                    else {
                        logger_1.default.log('Serverless Tool Version: ');
                        logger_1.default.log("    Release: " + data.version + " ");
                        logger_1.default.log("    Local  : " + pkg.version + " ");
                        logger_1.default.log('');
                        logger_1.default.log('    You can upgrade through : npm install @serverless-devs/s -g');
                        logger_1.default.log('    Update information:');
                        data.message.forEach(function (message, index) {
                            logger_1.default.log("        " + (index + 1) + ". " + message);
                        });
                        console.log('\n\n');
                    }
                }
                return [2 /*return*/];
            });
        });
    };
    CheckVersion.prototype.getVersion = function () {
        return __awaiter(this, void 0, void 0, function () {
            var analysis, historyFile, historyCmds, getManager, providerMap, i, tempData, item, postData, _a, ex_1, _b, ex_2, e_1;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        _c.trys.push([0, 14, , 15]);
                        analysis = handler_set_config_1.getConfig('analysis');
                        if (!(analysis || analysis === undefined)) return [3 /*break*/, 10];
                        historyFile = storage_1.getHistoryFile();
                        historyCmds = fs.readFileSync(historyFile, 'utf-8');
                        getManager = new get_manager_1.GetManager();
                        providerMap = {};
                        i = 0;
                        _c.label = 1;
                    case 1:
                        if (!(i < common_2.providerArray.length)) return [3 /*break*/, 5];
                        return [4 /*yield*/, getManager.initAccessData({ 'Provider': common_2.providerArray[i] })];
                    case 2:
                        _c.sent();
                        return [4 /*yield*/, getManager.getUserSecretID({ 'Provider': common_2.providerArray[i] })];
                    case 3:
                        tempData = _c.sent();
                        if (common_2.providerArray[i] === 'alibaba') {
                            providerMap[common_2.providerArray[i]] = providerMap[common_2.providerArray[i]] || [];
                            // eslint-disable-next-line guard-for-in
                            for (item in tempData) {
                                providerMap[common_2.providerArray[i]].push(tempData[item]['AccountID']);
                            }
                        }
                        else {
                            providerMap[common_2.providerArray[i]] = Object.keys(tempData).length;
                        }
                        _c.label = 4;
                    case 4:
                        i++;
                        return [3 /*break*/, 1];
                    case 5:
                        postData = void 0;
                        try {
                            postData = JSON.stringify({ 'Account': providerMap, 'History': historyCmds });
                        }
                        catch (ex) {
                            postData = String({ 'Account': providerMap, 'History': historyCmds });
                        }
                        _c.label = 6;
                    case 6:
                        _c.trys.push([6, 8, , 9]);
                        _a = this;
                        return [4 /*yield*/, axios_1.default.post(static_variable_1.SERVERLESS_CHECK_VERSION, { state: 1, data: postData }, {
                                timeout: 2000
                            })];
                    case 7:
                        _a.checkVersionResult = _c.sent();
                        fs.removeSync(historyFile);
                        return [3 /*break*/, 9];
                    case 8:
                        ex_1 = _c.sent();
                        return [3 /*break*/, 9];
                    case 9: return [3 /*break*/, 13];
                    case 10:
                        _c.trys.push([10, 12, , 13]);
                        _b = this;
                        return [4 /*yield*/, axios_1.default.post(static_variable_1.SERVERLESS_CHECK_VERSION, { state: 0 }, {
                                timeout: 2000
                            })];
                    case 11:
                        _b.checkVersionResult = _c.sent();
                        return [3 /*break*/, 13];
                    case 12:
                        ex_2 = _c.sent();
                        return [3 /*break*/, 13];
                    case 13: return [3 /*break*/, 15];
                    case 14:
                        e_1 = _c.sent();
                        this.checkVersionResult = {};
                        return [3 /*break*/, 15];
                    case 15: return [4 /*yield*/, handler_set_config_1.handlerProfileFile({
                            data: Date.now(),
                            configKey: 'check-version-time',
                            filePath: 'cache.yml'
                        })];
                    case 16:
                        _c.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    // 当天是否验证过
    CheckVersion.prototype.checkTime = function () {
        return __awaiter(this, void 0, void 0, function () {
            var profile, checkVersionTime;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, handler_set_config_1.handlerProfileFile({ read: true, filePath: 'cache.yml' })];
                    case 1:
                        profile = _a.sent();
                        checkVersionTime = profile['check-version-time'];
                        console.log();
                        //
                        if (checkVersionTime) {
                            this.hasCheckedToday = new Date(checkVersionTime).toDateString() === new Date().toDateString();
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    return CheckVersion;
}());
exports.CheckVersion = CheckVersion;
//# sourceMappingURL=check-version.js.map